/*
  Created by guanghui on 4/8/14.
http://www.idevgames.com/forums/thread-3010.html
*/

varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

uniform vec2 u_resolution;
uniform vec3 u_color;
uniform float u_radius;
uniform float u_threshold;

void main()
{
    vec2 unit = 1.0 / u_resolution;
    float radius = u_radius;
    vec4 accum = vec4(0.0);
    vec4 normal = vec4(0.0);
    
    normal = texture2D(CC_Texture0, vec2(v_texCoord.x, v_texCoord.y));
    
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius * unit.x, v_texCoord.y - radius * unit.y));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius * unit.x, v_texCoord.y - radius * unit.y));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x + radius * unit.x, v_texCoord.y + radius * unit.y));
    accum += texture2D(CC_Texture0, vec2(v_texCoord.x - radius * unit.x, v_texCoord.y + radius * unit.y));
    
    if (accum.a > u_threshold) {
        accum = vec4(u_color,1.0);
    } else {
        accum = vec4(u_color,0.0);
    }
    
    normal = ( accum * (1.0 - normal.a)) + (normal * normal.a);
    
    gl_FragColor = v_fragmentColor * normal;
}

